#include "emergency.h"

void setupRadio(RF24 radio) {
  radio.begin();
  radio.setAutoAck(false);
  radio.openWritingPipe(MSG_ADDR);
  radio.openReadingPipe(1, MSG_ADDR);
  radio.setChannel(100);          // 2.500 GHz to avoid Wifi bands
}

EmergencyMsg::EmergencyMsg(int srcId, int msgId) :
  srcId(srcId),
  msgId(msgId),
  ttl(MAX_TTL),
  knowledgeVector(),
  senderPath() {           // arrays zero initialized
}

EmergencyMsg::EmergencyMsg() :
  EmergencyMsg(0, 0) {     // zero initializes everything
}

void EmergencyMsg::printMsg() {
  Serial.print("MsgId ");
  Serial.print(this->srcId);
  Serial.print("-");
  Serial.print(this->msgId);
  Serial.print(": ");
  for (int i = 0; i < MAX_TTL; i++) {
    Serial.print(this->senderPath[i]);
    Serial.print(" ");
  }
  Serial.print("ttl: ");
  Serial.print(this->ttl);

  Serial.print(" Last Seen: ");
  for (int j = 0; j < MAX_ID; j++) {
    Serial.print(this->knowledgeVector[j]);
    Serial.print(" ");
  }
  Serial.println();
}
