#ifndef EMERGENCY_H
#define EMERGENCY_H

#include <Arduino.h>
#include <RF24.h>

const int MAX_TTL = 8;             // starting time to live value for messages
const int MAX_SRC = 10;            // maximum node ID for sources (exclusive)
const int MAX_ID = 10;             // maximum node ID for propagators
const byte MSG_ADDR[6] = "MNode";  // address to send out emergency messages

struct Location {
  float latitude;
  float longitude;
};

class EmergencyMsg {
public:
  byte ttl;                        // time to live: max 10 hops
  byte srcId;                      // ID of source node that created this msg
  int msgId;                       // ID of this message, set by source
  int knowledgeVector[MAX_ID];     // last message seen by each node
  byte senderPath[MAX_TTL];        // sender IDs in path of message

  EmergencyMsg(int srcId, int msgId);
  EmergencyMsg();
  void printMsg();                 // prints details about message
};

void setupRadio(RF24 radio);       // setup radio to receive messages

#endif
