#include <RF24.h>
#include "emergency.h"

RF24 _radio(7, 8);                 // nRF24L01 radio on SPI bus + pins 7, 8
const byte _sourceId = 0;          // ID of this source node
int _counter = 1;                  // message counter

void setup() {
  Serial.begin(115200);
  Serial.println("source start");
  setupRadio(_radio);
}

void loop() {
  /* Initialize and send out emergency message */
  Serial.print("Now sending ");
  EmergencyMsg eMsg(_sourceId, _counter);
  _radio.stopListening();
  eMsg.printMsg();
  _radio.write(&eMsg, sizeof(EmergencyMsg), 1);
  _counter++;
  /* Get propagated messages */
  unsigned long startTime = micros();
  _radio.startListening();
  while (micros() - startTime < 2000000) {    // 2 sec between messages
    if (_radio.available()) {
      _radio.read(&eMsg, sizeof(EmergencyMsg));
      /* Print received messages */
      Serial.print("Got response in ");
      Serial.print(micros() - startTime);
      Serial.print(" us. ");
      eMsg.printMsg();
    }
  }
}
