#include <SPI.h>
#include <RF24.h>

RF24 radio(7, 8);   // Hardware config: nRF24L01 radio on SPI bus + pins 7, 8
byte localAddr[6] = "RNode";    // address of this node
byte destAddr[6] = "TNode";     // address of master node to send to
char nodeId = '6';

void setup() {
  Serial.begin(115200);
  Serial.println("receiver start");

  radio.begin();
  radio.setAutoAck(false);
  radio.openWritingPipe(destAddr);
  radio.openReadingPipe(1, localAddr);
  radio.startListening();
  radio.setChannel(100);    // 2.500 GHz to avoid Wifi bands
}
/* Delay for a random amount of time */
void waitRand() {
  delayMicroseconds(random(50, 10000));
}

void loop() {
  unsigned long message;            // unused
  if (radio.available()) {
    while (radio.available()) {
      radio.read(&message, sizeof(unsigned long));
    }
    while (radio.testCarrier()) {   // if other nodes communicating,
      waitRand();                   //  wait and try a little later
      radio.stopListening();        // reset flag for testCarrier()
      radio.startListening();
    }
    radio.stopListening();
    radio.write(&nodeId, sizeof(char), 1);
    radio.startListening();
    Serial.print("Sent response ");
    Serial.println(message);
  }
}
