#include <SPI.h>
#include <RF24.h>

RF24 radio(7, 8);   // Hardware config: nRF24L01 radio on SPI bus + pins 7, 8
byte localAddr[6] = "TNode";   // address of this (master) node
byte destAddr[6] = "RNode";    // address to send to
unsigned long counter = 0;     // message counter
unsigned long numReceived = 0; // counter for received messages

void setup() {
  Serial.begin(115200);
  Serial.println("transmitter start");

  radio.begin();
  radio.setAutoAck(false);
  radio.openWritingPipe(destAddr);
  radio.openReadingPipe(1, localAddr);
  radio.setChannel(100);    // 2.500 GHz to avoid Wifi bands
}

void loop() {
  radio.stopListening();
  Serial.print("Now sending ");
  Serial.println(counter);
  /* Send current time as message */
  if (!radio.write(&counter, sizeof(unsigned long), 1)) {
    Serial.println("failed");
  }
  radio.startListening();
  /* Get response messages */
  unsigned long startTime = micros();
  while (micros() - startTime < 200000) {
    if (radio.available()) {
      char id;
      radio.read(&id, sizeof(char));
      unsigned long endTime = micros();
      numReceived++;
      /* Print RTT */
      Serial.print("Sent ");
      Serial.print(counter);
      Serial.print(", Got response ");
      Serial.print(id);
      Serial.print(", Round-trip delay ");
      Serial.print(endTime - startTime);
      Serial.println(" microseconds");
    }
  }

  Serial.print("Received messages: ");
  Serial.println(numReceived);
  delay(1000);
  counter++;
}
