package com.rkinney4.finalapp;

import android.content.Context;
import android.database.DataSetObserver;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.TextView;

import java.util.ArrayList;

/**
 * Created by Rachel on 4/18/2017.
 */

public class LogAdapter extends BaseAdapter {

    Context context;
    ArrayList<LogItem> items;

    LogAdapter(Context c) {
        context = c;
        items = new ArrayList<>();
    }

    @Override
    public int getCount() {
        return items.size();
    }

    @Override
    public Object getItem(int position) {
        return items.get(position);
    }

    //TODO
    @Override
    public long getItemId(int i) {
        return 0;
    }

    //TODO
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // inflate the layout for each list row
        if (convertView == null) {
            convertView = LayoutInflater.from(context).
                    inflate(R.layout.log_item, parent, false);
        }

        if (position > (items.size() - 1)) {
            return null;
        }

        LogItem thisItem = items.get(position);
        ((TextView) convertView.findViewById(R.id.time)).setText(thisItem.time);
        ((TextView) convertView.findViewById(R.id.type)).setText(thisItem.type);
        ((TextView) convertView.findViewById(R.id.message)).setText(thisItem.message);

        return convertView;
    }

    public void addItem(String time, String type, String message) {
        items.add(new LogItem(time, type, message));
    }

    public void clear() {
        items.clear();
    }

    private class LogItem {
        String time;
        String type;
        String message;

        LogItem(String time, String type, String message) {
            this.time = time;
            this.type = type;
            this.message = message;
        }

        public String toString() {
            return ("{" + time + ", " + type + ", " + message + "}");
        }
    }
}
