package com.rkinney4.finalapp;


import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.media.RingtoneManager;
import android.net.Uri;
import android.support.v4.app.NotificationCompat;
import android.util.EventLog;
import android.util.Log;
import android.widget.Toast;


import com.rkinney4.finalapp.MainActivity;
import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;
import android.support.v4.content.LocalBroadcastManager;


public class MyFirebaseMessagingService extends FirebaseMessagingService{

    private static final String TAG = "MyFirebaseMsgService";


    private LocalBroadcastManager broadcaster;

    @Override
    public void onCreate() {

        broadcaster = LocalBroadcastManager.getInstance(this);
    }
    /**
     * Called when message is received.
     *
     * @param remoteMessage Object representing the message received from MyFirebaseInstanceIdService Cloud Messaging.
     */
    // [START receive_message]
    @Override
    public void onMessageReceived(RemoteMessage remoteMessage) {
        // [START_EXCLUDE]
        // There are two types of messages data messages and notification messages. Data messages are handled
        // here in onMessageReceived whether the app is in the foreground or background. Data messages are the type
        // traditionally used with GCM. Notification messages are only received here in onMessageReceived when the app
        // is in the foreground. When the app is in the background an automatically generated notification is displayed.
        // When the user taps on the notification they are returned to the app. Messages containing both notification
        // and data payloads are treated as notification messages. The MyFirebaseInstanceIdService console always sends notification
        // messages. For more see: https://firebase.google.com/docs/cloud-messaging/concept-options
        // [END_EXCLUDE]

        // TODO(developer): Handle FCM messages here.
        // Not getting messages here? See why this may be: https://goo.gl/39bRNJ
        //Long end = System.currentTimeMillis();
//        Long end = System.nanoTime();
//        Log.d(TAG, "From: " + remoteMessage.getFrom());
        Long end = System.nanoTime();
        // Check if message contains a data payload.
        if (remoteMessage.getData().size() > 0) {
            String e_id = remoteMessage.getData().get("e_id");
            double lat = Double.parseDouble(remoteMessage.getData().get("lat"));
            double lon = Double.parseDouble(remoteMessage.getData().get("lon"));

            Log.d(TAG, "received message: " + e_id);
            Intent intent = new Intent("Emergency");
            intent.putExtra("e_id", e_id);
            intent.putExtra("lat", lat);
            intent.putExtra("lon", lon);
            broadcaster.sendBroadcast(intent);
            /*
            if (type.equals("emergency")) {
                Log.d(TAG, "recieved emergency ping, sending to main");
                Intent intent = new Intent("Emergency");
                intent.putExtra("eid", e_id)
                broadcaster.sendBroadcast(intent);
            } else if (type.equals("ping")) {
                Intent intent = new Intent("MyData");
                intent.putExtra("EndTime", end);
                broadcaster.sendBroadcast(intent);
            } else {
                Log.e(TAG, "unspecified type");
            }
            */
            Log.d(TAG, "Message data payload: " + remoteMessage.getData());
            Log.d("received service", end.toString());
        }

        // Check if message contains a notification payload.
        if (remoteMessage.getNotification() != null) {
            Log.d(TAG, "Message Notification Body: " + remoteMessage.getNotification().getBody());
        }
    }
}
