package com.rkinney4.finalapp;

import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.text.method.LinkMovementMethod;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

public class Settings extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_settings);
        final SharedPreferences prefs = this.getSharedPreferences(
            getString(R.string.prefs), Settings.MODE_PRIVATE);

        //Setup Toolbar
        Toolbar myToolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(myToolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setTitle(R.string.activity_settings);

        /* **** Setup Settings **** */
        LinearLayout layout;
        Spinner spin;
        ArrayAdapter<CharSequence> adapter;
        ((TextView) findViewById(R.id.GeneralCategory).findViewById(R.id.CategoryText)).setText(R.string.set_cat_general);
        ((TextView) findViewById(R.id.CreditsCategory).findViewById(R.id.CategoryText)).setText(R.string.set_cat_credits);

        // Mode
        layout = (LinearLayout) (findViewById(R.id.ApplicationMode));
        ((TextView)layout.findViewById(R.id.settingMainText)).setText(R.string.set_main_mode);
        ((TextView)layout.findViewById(R.id.settingSubText)).setText(R.string.set_sub_mode);
        spin = new Spinner(this);
        adapter = ArrayAdapter.createFromResource(this, R.array.set_modes, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spin.setAdapter(adapter);
        ((FrameLayout) layout.findViewById(R.id.settingControl)).addView(spin);
        spin.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
                SharedPreferences.Editor editor = prefs.edit();
                editor.putInt(getString(R.string.pref_mode), position);
                editor.apply();
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        spin.setSelection(prefs.getInt(getString(R.string.pref_mode), 0));

        // Vehicle Preference
        layout = (LinearLayout) (findViewById(R.id.VehiclePreference));
        ((TextView)layout.findViewById(R.id.settingMainText)).setText(R.string.set_main_emer);
        ((TextView)layout.findViewById(R.id.settingSubText)).setText(R.string.set_sub_emer);
        spin = new Spinner(this);
        adapter = ArrayAdapter.createFromResource(this, R.array.set_emer_vehicles, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spin.setAdapter(adapter);
        ((FrameLayout) layout.findViewById(R.id.settingControl)).addView(spin);
        spin.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
                SharedPreferences.Editor editor = prefs.edit();
                editor.putInt(getString(R.string.pref_vehicle), position);
                editor.apply();
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });
        spin.setSelection(prefs.getInt(getString(R.string.pref_vehicle), 0));

        //Credits
        ((TextView) findViewById(R.id.credit_icons)).setMovementMethod(LinkMovementMethod.getInstance());

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.toolbar, menu);
        menu.getItem(0).setVisible(false);
        return true;
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return true;
    }
}
