package com.example.ppianto1.firebasetest;

import android.content.IntentFilter;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.content.LocalBroadcastManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.Button;
import android.view.View;
import android.widget.Toast;


import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.firebase.iid.FirebaseInstanceId;
import com.google.firebase.messaging.FirebaseMessaging;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.location.Location;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationServices;
import android.support.v4.app.ActivityCompat;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.telephony.TelephonyManager;
import android.net.ConnectivityManager;
import android.content.pm.PackageManager;






import com.google.firebase.iid.FirebaseInstanceId;

import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity implements GoogleApiClient.OnConnectionFailedListener,
        GoogleApiClient.ConnectionCallbacks, LocationListener{

    private static final String TAG = "MainActivity";
    Location location;
    LocationRequest locReq;
    RequestQueue dataQueue;
    String token;
    Long end;
    Long start;
    Long serverEnd;
    Long serverRtt;
    Long rtt;
    Double lat;
    Double lon;
    String vid;
    GoogleApiClient gApiClient;
    boolean cont; //flag to continuously send to server and receive from firebase
    ConnectivityManager connMgr;
    TelephonyManager teleMgr;
    boolean acceptNoLocation;

    static final int REQUEST_LOCATION = 1;



    @Override
    protected void onCreate(Bundle savedInstanceState) {

        if (dataQueue == null) {
            dataQueue = Volley.newRequestQueue(this);
        }

        //manages messages from Firebase for RTT and emergency alerts
        LocalBroadcastManager.getInstance(this).registerReceiver((mMessageReceiver), new IntentFilter("MyData"));
        LocalBroadcastManager.getInstance(this).registerReceiver((emergencyMessageReceiver), new IntentFilter("Emergency"));
        // Get Connection Objects
        teleMgr = (TelephonyManager) this.getSystemService(Context.TELEPHONY_SERVICE);
        connMgr = (ConnectivityManager) this.getSystemService(Context.CONNECTIVITY_SERVICE);

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        acceptNoLocation = false;

        // Handle Location API
        gApiClient = new GoogleApiClient.Builder(this)
                .enableAutoManage(this, this)
                .addApi(LocationServices.API)
                .addConnectionCallbacks(this)
                .addOnConnectionFailedListener(this)
                .build();
        locReq = LocationRequest.create()
                .setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY)
                .setInterval(1000)        //   1 second, in milliseconds
                .setFastestInterval(250); // 1/4 second, in milliseconds


        if (getIntent().getExtras() != null) {
            for (String key : getIntent().getExtras().keySet()) {
                Object value = getIntent().getExtras().get(key);
                Log.d(TAG, "Key: " + key + " Value: " + value);
            }
        }

        //TODO rewrite multiple sending loop, figure why first 2 gps locs are all 0's
        //registerEmergencyVehicle();
        sendRequest();
        //button that sends messages to server, remove in production
        Button sendButton = (Button) findViewById(R.id.button2);
        sendButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cont = true;
                sendRequest();
            }
        });

        //button that stops server, remove in production
        Button stopButton = (Button) findViewById(R.id.button3);
        stopButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                cont = false;
            }
        });

        //button that sends emergency alert to server, remove in production
        Button emergencyButton = (Button) findViewById(R.id.button4);
        emergencyButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                emergencyPing();
            }
        });
    }

    //Sends an emergency message to FireBase
    private void emergencyPing() {
        Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {}
        };

        Response.ErrorListener errorListener = new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e("sendDataPoint", error.toString());
            }
        };

        //send to JSON object to server
        try {
            getLocation();
            JsonObjectRequest request = new JsonObjectRequest(
                    Request.Method.POST, "https://cloud2.cnds.jhu.edu/emergency", (new JSONObject())
                    .put("version", "1.0")
                    .put("id", token)
                    .put("lat", lat)
                    .put("lon", lon),
            responseListener, errorListener);
            Log.d("Message Sent", start.toString());
            dataQueue.add(request);
            Log.d("FB instance", "added to queue");
        }catch(JSONException e) {
            Log.e("asJsonObject", String.valueOf(e));
        }
    }

    //calculates the RTT from the server
    private void sendServerRTT() {
        Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {}
        };

        Response.ErrorListener errorListener = new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e("RTT", error.toString());
            }
        };

        try {
            JsonObjectRequest request = new JsonObjectRequest(
                    Request.Method.POST, "https://cloud2.cnds.jhu.edu/server_data", (new JSONObject())
                    .put("version", "1.0")
                    .put("id", token)
                    .put("RTT", serverRtt)
                    .put("lat", lat)
                    .put("lon", lon)
                    .put("network", getNetworkClass()),
                    responseListener, errorListener);
            Log.d("Server RTT sent", serverRtt.toString());
            dataQueue.add(request);
            Log.d("FB instance", "added to queue");
        }catch(JSONException e) {
            Log.e("asJsonObject", String.valueOf(e));
        }

    }

    private void registerEmergencyVehicle() {
        Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {
                try {
                    vid = response.get("vid").toString(); // TODO check the format of the response object
                    Log.d(TAG, vid);
                }catch (JSONException e) {
                    Log.d(TAG, response.toString());
                    Log.d(TAG, "Bad json object in register Emergency vehicle");
                }

            }
        };

        Response.ErrorListener errorListener = new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d("registerEmerVehicle", error.toString());
            }
        };

        //sends the token of the app running and the gps coordinates
        try {
            getLocation();
            JsonObjectRequest request = new JsonObjectRequest(
                    Request.Method.POST, "https://cloud2.cnds.jhu.edu/emergency_vehicles", (new JSONObject())
                    .put("version", "1.0")
                    .put("lat", lat)
                    .put("lon", lon),
                    responseListener, errorListener);
            Log.d("Message Sent", start.toString());
            dataQueue.add(request);
            Log.d("FB instance", "added to queue");
        }catch(JSONException e) {
            Log.e("asJsonObject", String.valueOf(e));
        }
    }


    private void sendRequest() {

        token = FirebaseInstanceId.getInstance().getToken();
        // Log and toast
        String msg = token;
        Log.d(TAG, msg);
        Log.d(TAG, token);
        //Toast.makeText(MainActivity.this, msg, Toast.LENGTH_SHORT).show();

        //this waits for the response from the server, at the moment the value of emergency should always be false
        Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {
                try {
                    Log.d("Response from server", response.get("emergency_vehicles").toString());

                    List<String> list = new ArrayList<String>();
                    JSONArray array = response.getJSONArray("emergency_vehicles");
                    if (array.length() > 0) {
                        Toast.makeText(MainActivity.this, "emergency from redis", Toast.LENGTH_SHORT).show();
                    }
                }catch (JSONException e) {
                    Log.d(TAG, response.toString());
                    Log.d(TAG, "Bad json object");
                }
                finally {
                    if(cont)
                        sendRequest();
                }
            }
        };

        Response.ErrorListener errorListener = new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e("sendDataPoint", error.toString());
            }
        };

        //sends the token of the app running and the gps coordinates
        try {
            getLocation();
            JsonObjectRequest request = new JsonObjectRequest(
                    Request.Method.POST, "https://cloud2.cnds.jhu.edu/car_loc", (new JSONObject())
                    .put("version", "1.0")
                    .put("id", token)
                    .put("lat", lat)
                    .put("lon", lon),
                    responseListener, errorListener);
            start = new Long(System.nanoTime());

            Log.d("Message Sent", start.toString());

            dataQueue.add(request);
            Log.d("FB instance", "added to queue");
        }catch(JSONException e) {
            Log.e("asJsonObject", String.valueOf(e));
        }
    }


    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {
            /* Handle Google Play Services Connection Failure */
        // May need to add handling here if problem is encountered
        //Toast.makeText(this, R.string.play_serv_error,Toast.LENGTH_LONG).show();

        acceptNoLocation = true;
        int onConnectionFailed = Log.w("onConnectionFailed", "acceptingNoLocation - Google Play, Err: " + connectionResult.getErrorMessage());

    }

    @Override
    public void onConnected(@Nullable Bundle bundle) {
        Log.i("onConnected", "Google Play - CONNECTION SUCCESSFUL");

    }

    @Override
    public void onConnectionSuspended(int i) {
        Log.i("onConnectionSuspended", "Reason: " + ((i == CAUSE_NETWORK_LOST) ? "Network Lost" : "Service Disconnected"));

    }


    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        if (requestCode == REQUEST_LOCATION ) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_DENIED) {
                acceptNoLocation = true;
                Log.w("onReqPermissResult", "Location Permission Denied, acceptingNoLocation = true");
            } else {
                Log.i("onReqPermissResult", "Location Permissions Granted");
            }
        }
    }

    //Gets the current location from the os
    private int getLocation() {
        if (!acceptNoLocation) {
            try {
                Location loc;
                loc = LocationServices.FusedLocationApi.getLastLocation(gApiClient);
                if (loc == null) {
                    Log.i("getLocation", "Location null, requesting updates");
                    LocationServices.FusedLocationApi.requestLocationUpdates(gApiClient, locReq, this);
                } else {
                    onLocationChanged(loc);
                }
            } catch (SecurityException e) {
                ActivityCompat.requestPermissions(this,
                        new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                        1);
                location = null;
                return -1;
            } catch (IllegalStateException e) {
                Log.w("getLocation", "onStop probably called. Error: e.getMessage()");
                return -1;
            }
        } else {
            location = null;
        }
        return 0;
    }
    @Override
    public void onLocationChanged(Location newLocation) {

        location = newLocation;
        lat = location.getLatitude();
        lon = location.getLongitude();


        Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {}
        };

        Response.ErrorListener errorListener = new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.e("sendDataPoint", error.toString());
            }
        };

        //send to the user the new location information
        try {
            JsonObjectRequest request = new JsonObjectRequest(
                    Request.Method.POST, "cloud2.cnds.jhu.edu:8888/token", (new JSONObject())
                    .put("version", "1.0")
                    .put("id", token)
                    .put("lat", lat)
                    .put("lon", lon),
                    responseListener, errorListener);
            dataQueue.add(request);
            Log.d("FB instance", "added to queue");
        }catch(JSONException e) {
            Log.e("asJsonObject", String.valueOf(e));
        }

    }

    /** Listens for a response from Firebase to measure RTT. Then sends another message to measure RTT
     * */
    private BroadcastReceiver mMessageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            end = intent.getExtras().getLong("EndTime");
            rtt = (end-start) / 1000000;
            Log.d("received MainActivity", end.toString());
            Log.d("RTT", rtt.toString());

            Response.Listener<JSONObject> responseListener = new Response.Listener<JSONObject>() {
                @Override
                public void onResponse(JSONObject response) {}
            };

            Response.ErrorListener errorListener = new Response.ErrorListener() {
                @Override
                public void onErrorResponse(VolleyError error) {
                    Log.e("sendDataPoint", error.toString());
                }
            };

            //tries to send a JSON object to server with the gps coordinates and RTT
            /*try {
                JsonObjectRequest request = new JsonObjectRequest(
                        Request.Method.POST, "https://cloud2.cnds.jhu.edu/hybrid_data", (new JSONObject())
                        .put("version", "1.0")
                        .put("id", token)
                        .put("lat", lat)
                        .put("lon", lon)
                        .put("RTT", rtt)
                        .put("network", getNetworkClass()),
                        responseListener, errorListener);
                start = new Long(System.nanoTime());

                Log.d("DataPoint Sent", start.toString());
                dataQueue.add(request);
                Log.d("FB instance", "added to queue");
            }catch(JSONException e) {
                Log.e("asJsonObject", String.valueOf(e));
            }*/

            //keep sending messages until the user presses stop
            if (cont) {
                sendRequest();
                Log.d("Resending", "sending another");
            }
        }
    };

    /**Listens for a message from FireBase and makes a toast
     * */
    private BroadcastReceiver emergencyMessageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            Log.d(TAG, "emergency!");
            Toast.makeText(MainActivity.this, "emergency", Toast.LENGTH_SHORT).show();

        }
    };


    /**Method that determines what kind of network the mobile device is connected to
     * @return String the name of the type of network
     * */
    public String getNetworkClass() {
        final android.net.NetworkInfo wifi = connMgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
        final android.net.NetworkInfo mobile = connMgr.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
        if (wifi.isConnectedOrConnecting ()) {
            return "WIFI";
        } else if (mobile.isConnectedOrConnecting ()) {
            int networkType = teleMgr.getNetworkType();
            switch (networkType) {
                case TelephonyManager.NETWORK_TYPE_GPRS:
                case TelephonyManager.NETWORK_TYPE_EDGE:
                case TelephonyManager.NETWORK_TYPE_CDMA:
                case TelephonyManager.NETWORK_TYPE_1xRTT:
                case TelephonyManager.NETWORK_TYPE_IDEN:
                    return "2G";
                case TelephonyManager.NETWORK_TYPE_UMTS:
                case TelephonyManager.NETWORK_TYPE_EVDO_0:
                case TelephonyManager.NETWORK_TYPE_EVDO_A:
                case TelephonyManager.NETWORK_TYPE_HSDPA:
                case TelephonyManager.NETWORK_TYPE_HSUPA:
                case TelephonyManager.NETWORK_TYPE_HSPA:
                case TelephonyManager.NETWORK_TYPE_EVDO_B:
                case TelephonyManager.NETWORK_TYPE_EHRPD:
                case TelephonyManager.NETWORK_TYPE_HSPAP:
                    return "3G";
                case TelephonyManager.NETWORK_TYPE_LTE:
                    return "4G";
                default:
                    Log.e("getNetworkClass", "Unknown Type: " + networkType);
                    return "Unknown";
            }
        } else {
            return "No Network";
        }
    }
}
