/**
 * Created by pj on 4/2/17.
 */

package com.example.ppianto1.firebasetest;


import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.media.RingtoneManager;
import android.net.Uri;
import android.support.v4.app.NotificationCompat;
import android.util.EventLog;
import android.util.Log;
import android.widget.Toast;


import com.example.ppianto1.firebasetest.MainActivity;
import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;
import android.support.v4.content.LocalBroadcastManager;


public class MyFirebaseMessagingService extends FirebaseMessagingService{

    private static final String TAG = "MyFirebaseMsgService";


    private LocalBroadcastManager broadcaster;

    @Override
    public void onCreate() {

        broadcaster = LocalBroadcastManager.getInstance(this);
    }
    /**
     * Called when message is received.
     *
     * @param remoteMessage Object representing the message received from MyFirebaseInstanceIdService Cloud Messaging.
     */
    // [START receive_message]
    @Override
    public void onMessageReceived(RemoteMessage remoteMessage) {
        // [START_EXCLUDE]
        // There are two types of messages data messages and notification messages. Data messages are handled
        // here in onMessageReceived whether the app is in the foreground or background. Data messages are the type
        // traditionally used with GCM. Notification messages are only received here in onMessageReceived when the app
        // is in the foreground. When the app is in the background an automatically generated notification is displayed.
        // When the user taps on the notification they are returned to the app. Messages containing both notification
        // and data payloads are treated as notification messages. The MyFirebaseInstanceIdService console always sends notification
        // messages. For more see: https://firebase.google.com/docs/cloud-messaging/concept-options
        // [END_EXCLUDE]

        // TODO(developer): Handle FCM messages here.
        // Not getting messages here? See why this may be: https://goo.gl/39bRNJ
        //Long end = System.currentTimeMillis();
        Long end = System.nanoTime();
        Log.d(TAG, "From: " + remoteMessage.getFrom());

        // Check if message contains a data payload.
        //Toast.makeText(getApplicationContext(), "HI", Toast.LENGTH_SHORT).show();

        if (remoteMessage.getData().size() > 0) {
            String type = remoteMessage.getData().get("type");
            if (type.equals("emergency")) {
                Intent intent = new Intent("Emergency");
                broadcaster.sendBroadcast(intent);
            } else if (type.equals("ping")) {
                //Toast.makeText(getApplicationContext(), remoteMessage.getData().toString(), Toast.LENGTH_SHORT).show();
                Intent intent = new Intent("MyData");
                intent.putExtra("EndTime", end);
                broadcaster.sendBroadcast(intent);
            } else {
                Log.e(TAG, "unspecified type");
            }

            Log.d(TAG, "Message data payload: " + remoteMessage.getData());
            Log.d("received service", end.toString());




        }

        // Check if message contains a notification payload.
        if (remoteMessage.getNotification() != null) {
            Log.d(TAG, "Message Notification Body: " + remoteMessage.getNotification().getBody());
        }
    }
}
